diff --git a/audio/alsaaudio.c b/audio/alsaaudio.c
index 564d632..cd553c2 100644
--- a/audio/alsaaudio.c
+++ b/audio/alsaaudio.c
@@ -24,7 +24,6 @@
 #include <alsa/asoundlib.h>
 #include "qemu-common.h"
 #include "main-loop.h"
-#include "qemu-char.h"
 #include "audio.h"
 
 #if QEMU_GNUC_PREREQ(4, 3)
diff --git a/audio/ossaudio.c b/audio/ossaudio.c
index 45abe39..8249a00 100644
--- a/audio/ossaudio.c
+++ b/audio/ossaudio.c
@@ -33,7 +33,6 @@
 #include "qemu-common.h"
 #include "main-loop.h"
 #include "host-utils.h"
-#include "qemu-char.h"
 #include "audio.h"
 
 #define AUDIO_CAP "oss"
diff --git a/block/raw-posix.c b/block/raw-posix.c
index 28d439f..5f868bf 100644
--- a/block/raw-posix.c
+++ b/block/raw-posix.c
@@ -23,7 +23,6 @@
  */
 #include "qemu-common.h"
 #include "qemu-timer.h"
-#include "qemu-char.h"
 #include "qemu-log.h"
 #include "block_int.h"
 #include "module.h"
diff --git a/bt-host.c b/bt-host.c
index 8b47370..3118645 100644
--- a/bt-host.c
+++ b/bt-host.c
@@ -18,7 +18,6 @@
  */
 
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "net.h"
 #include "bt-host.h"
 #include "main-loop.h"
diff --git a/bt-vhci.c b/bt-vhci.c
index 878460a..6fecb66 100644
--- a/bt-vhci.c
+++ b/bt-vhci.c
@@ -18,7 +18,6 @@
  */
 
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "net.h"
 #include "hw/bt.h"
 #include "main-loop.h"
diff --git a/buffered_file.c b/buffered_file.c
index ed92df1..068c0d7 100644
--- a/buffered_file.c
+++ b/buffered_file.c
@@ -16,7 +16,6 @@
 #include "qemu-common.h"
 #include "hw/hw.h"
 #include "qemu-timer.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 
 //#define DEBUG_BUFFERED_FILE
diff --git a/console.c b/console.c
index 3f3d254..eb46d79 100644
--- a/console.c
+++ b/console.c
@@ -25,6 +25,7 @@
 #include "console.h"
 #include "qemu-timer.h"
 #include "qmp-commands.h"
+#include "qemu-char.h"
 
 //#define DEBUG_CONSOLE
 #define DEFAULT_BACKSCROLL 512
diff --git a/console.h b/console.h
index 6099d8d..a9f8952 100644
--- a/console.h
+++ b/console.h
@@ -1,7 +1,6 @@
 #ifndef CONSOLE_H
 #define CONSOLE_H
 
-#include "qemu-char.h"
 #include "qdict.h"
 #include "notify.h"
 #include "monitor.h"
diff --git a/event_notifier.c b/event_notifier.c
index 23d5128..f0d10bb 100644
--- a/event_notifier.c
+++ b/event_notifier.c
@@ -12,7 +12,6 @@
 
 #include "qemu-common.h"
 #include "event_notifier.h"
-#include "qemu-char.h"
 #include "main-loop.h"
 
 #ifdef CONFIG_EVENTFD
diff --git a/hmp.c b/hmp.c
index 2b97982..264f226 100644
--- a/hmp.c
+++ b/hmp.c
@@ -15,6 +15,7 @@
 
 #include "hmp.h"
 #include "net.h"
+#include "qemu-char.h"
 #include "qemu-option.h"
 #include "qemu-timer.h"
 #include "qmp-commands.h"
diff --git a/hw/9pfs/virtio-9p-coth.c b/hw/9pfs/virtio-9p-coth.c
index 25556cc..9368df7 100644
--- a/hw/9pfs/virtio-9p-coth.c
+++ b/hw/9pfs/virtio-9p-coth.c
@@ -12,7 +12,6 @@
  *
  */
 
-#include "qemu-char.h"
 #include "fsdev/qemu-fsdev.h"
 #include "qemu-thread.h"
 #include "qemu-coroutine.h"
diff --git a/hw/ivshmem.c b/hw/ivshmem.c
index 5c4ccb8..0c62d43 100644
--- a/hw/ivshmem.c
+++ b/hw/ivshmem.c
@@ -24,6 +24,7 @@
 #include "migration.h"
 #include "qerror.h"
 #include "event_notifier.h"
+#include "qemu-char.h"
 
 #include <sys/mman.h>
 #include <sys/types.h>
diff --git a/hw/qdev-properties.c b/hw/qdev-properties.c
index 8aca0d4..fab3888 100644
--- a/hw/qdev-properties.c
+++ b/hw/qdev-properties.c
@@ -4,6 +4,7 @@
 #include "blockdev.h"
 #include "hw/block-common.h"
 #include "net/hub.h"
+#include "qemu-char.h"
 
 void *qdev_get_prop_ptr(DeviceState *dev, Property *prop)
 {
diff --git a/hw/qdev.h b/hw/qdev.h
index c6ac636..8ba1613 100644
--- a/hw/qdev.h
+++ b/hw/qdev.h
@@ -3,7 +3,6 @@
 
 #include "hw.h"
 #include "qemu-queue.h"
-#include "qemu-char.h"
 #include "qemu-option.h"
 #include "qapi/qapi-visit-core.h"
 #include "qemu/object.h"
diff --git a/hw/spapr_hcall.c b/hw/spapr_hcall.c
index 194d9c2..ea6119e 100644
--- a/hw/spapr_hcall.c
+++ b/hw/spapr_hcall.c
@@ -1,8 +1,6 @@
 #include "sysemu.h"
 #include "cpu.h"
-#include "qemu-char.h"
 #include "sysemu.h"
-#include "qemu-char.h"
 #include "helper_regs.h"
 #include "hw/spapr.h"
 
diff --git a/hw/strongarm.c b/hw/strongarm.c
index 7150eeb..4847e43 100644
--- a/hw/strongarm.c
+++ b/hw/strongarm.c
@@ -30,6 +30,7 @@
 #include "strongarm.h"
 #include "qemu-error.h"
 #include "arm-misc.h"
+#include "qemu-char.h"
 #include "sysemu.h"
 #include "ssi.h"
 
diff --git a/hw/xen_disk.c b/hw/xen_disk.c
index e6bb2f2..423b580 100644
--- a/hw/xen_disk.c
+++ b/hw/xen_disk.c
@@ -36,7 +36,6 @@
 #include <sys/uio.h>
 
 #include "hw.h"
-#include "qemu-char.h"
 #include "xen_backend.h"
 #include "xen_blkif.h"
 #include "blockdev.h"
diff --git a/hw/xen_nic.c b/hw/xen_nic.c
index cf7d559..dadacb1 100644
--- a/hw/xen_nic.c
+++ b/hw/xen_nic.c
@@ -39,7 +39,6 @@
 #include "net.h"
 #include "net/checksum.h"
 #include "net/util.h"
-#include "qemu-char.h"
 #include "xen_backend.h"
 
 #include <xen/io/netif.h>
diff --git a/hw/xilinx_axidma.c b/hw/xilinx_axidma.c
index 0e28c51..264cb6e 100644
--- a/hw/xilinx_axidma.c
+++ b/hw/xilinx_axidma.c
@@ -23,7 +23,6 @@
  */
 
 #include "sysbus.h"
-#include "qemu-char.h"
 #include "qemu-timer.h"
 #include "ptimer.h"
 #include "qemu-log.h"
diff --git a/hw/xilinx_axienet.c b/hw/xilinx_axienet.c
index eec155d..c680187 100644
--- a/hw/xilinx_axienet.c
+++ b/hw/xilinx_axienet.c
@@ -23,7 +23,6 @@
  */
 
 #include "sysbus.h"
-#include "qemu-char.h"
 #include "qemu-log.h"
 #include "net.h"
 #include "net/checksum.h"
diff --git a/hw/xtensa_lx60.c b/hw/xtensa_lx60.c
index 0c407d3..dc2f7ce 100644
--- a/hw/xtensa_lx60.c
+++ b/hw/xtensa_lx60.c
@@ -36,6 +36,7 @@
 #include "sysbus.h"
 #include "flash.h"
 #include "blockdev.h"
+#include "qemu-char.h"
 #include "xtensa_bootparam.h"
 
 typedef struct LxBoardDesc {
diff --git a/iohandler.c b/iohandler.c
index a2d871b..fb0bc11 100644
--- a/iohandler.c
+++ b/iohandler.c
@@ -24,7 +24,6 @@
 
 #include "config-host.h"
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "qemu-queue.h"
 #include "main-loop.h"
 
diff --git a/migration-exec.c b/migration-exec.c
index 519af57..ed63187 100644
--- a/migration-exec.c
+++ b/migration-exec.c
@@ -18,7 +18,6 @@
 #include "qemu-common.h"
 #include "qemu_socket.h"
 #include "migration.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 #include <sys/types.h>
diff --git a/migration-fd.c b/migration-fd.c
index ce6932d..b1e3cca 100644
--- a/migration-fd.c
+++ b/migration-fd.c
@@ -17,7 +17,6 @@
 #include "qemu_socket.h"
 #include "migration.h"
 #include "monitor.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 #include "qemu_socket.h"
diff --git a/migration-tcp.c b/migration-tcp.c
index 46f6ac5..7006fdb 100644
--- a/migration-tcp.c
+++ b/migration-tcp.c
@@ -16,7 +16,6 @@
 #include "qemu-common.h"
 #include "qemu_socket.h"
 #include "migration.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 
diff --git a/migration-unix.c b/migration-unix.c
index ed3db3a..570bc94 100644
--- a/migration-unix.c
+++ b/migration-unix.c
@@ -16,7 +16,6 @@
 #include "qemu-common.h"
 #include "qemu_socket.h"
 #include "migration.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 
diff --git a/monitor.h b/monitor.h
index b6e7d95..76c59f7 100644
--- a/monitor.h
+++ b/monitor.h
@@ -2,7 +2,6 @@
 #define MONITOR_H
 
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "qerror.h"
 #include "qdict.h"
 #include "block.h"
diff --git a/net/slirp.c b/net/slirp.c
index bf86a44..422a3a4 100644
--- a/net/slirp.c
+++ b/net/slirp.c
@@ -35,6 +35,7 @@
 #include "monitor.h"
 #include "qemu_socket.h"
 #include "slirp/libslirp.h"
+#include "qemu-char.h"
 
 static int get_str_sep(char *buf, int buf_size, const char **pp, int sep)
 {
diff --git a/net/socket.c b/net/socket.c
index b75d567..c9019eb 100644
--- a/net/socket.c
+++ b/net/socket.c
@@ -26,7 +26,6 @@
 #include "net.h"
 #include "clients.h"
 #include "monitor.h"
-#include "qemu-char.h"
 #include "qemu-common.h"
 #include "qemu-error.h"
 #include "qemu-option.h"
diff --git a/net/tap.c b/net/tap.c
index df89caa..0230ae5 100644
--- a/net/tap.c
+++ b/net/tap.c
@@ -37,7 +37,6 @@
 #include "clients.h"
 #include "monitor.h"
 #include "sysemu.h"
-#include "qemu-char.h"
 #include "qemu-common.h"
 #include "qemu-error.h"
 
diff --git a/net/vde.c b/net/vde.c
index 275bda9..cc5a07d 100644
--- a/net/vde.c
+++ b/net/vde.c
@@ -27,7 +27,6 @@
 
 #include "net.h"
 #include "clients.h"
-#include "qemu-char.h"
 #include "qemu-common.h"
 #include "qemu-option.h"
 
diff --git a/qemu-aio.h b/qemu-aio.h
index a61cd83..40053b4 100644
--- a/qemu-aio.h
+++ b/qemu-aio.h
@@ -15,7 +15,6 @@
 #define QEMU_AIO_H
 
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "main-loop.h"
 
 typedef struct BlockDriverAIOCB BlockDriverAIOCB;
diff --git a/qmp.c b/qmp.c
index 31bc3bf..1d3f7d7 100644
--- a/qmp.c
+++ b/qmp.c
@@ -16,6 +16,7 @@
 #include "qemu-common.h"
 #include "sysemu.h"
 #include "qmp-commands.h"
+#include "qemu-char.h"
 #include "ui/qemu-spice.h"
 #include "ui/vnc.h"
 #include "kvm.h"
diff --git a/savevm.c b/savevm.c
index b080d37..7176424 100644
--- a/savevm.c
+++ b/savevm.c
@@ -76,7 +76,6 @@
 #include "monitor.h"
 #include "sysemu.h"
 #include "qemu-timer.h"
-#include "qemu-char.h"
 #include "audio/audio.h"
 #include "migration.h"
 #include "qemu_socket.h"
diff --git a/ui/qemu-spice.h b/ui/qemu-spice.h
index 3299da8..5857b8a 100644
--- a/ui/qemu-spice.h
+++ b/ui/qemu-spice.h
@@ -24,7 +24,6 @@
 
 #include "qemu-option.h"
 #include "qemu-config.h"
-#include "qemu-char.h"
 #include "monitor.h"
 
 extern int using_spice;