diff --git a/audio/alsaaudio.c b/audio/alsaaudio.c
index cd553c2..2642d65 100644
--- a/audio/alsaaudio.c
+++ b/audio/alsaaudio.c
@@ -24,7 +24,7 @@
 #include <alsa/asoundlib.h>
 #include "qemu-common.h"
 #include "main-loop.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #if QEMU_GNUC_PREREQ(4, 3)
 #pragma GCC diagnostic ignored "-Waddress"
diff --git a/audio/audio.c b/audio/audio.c
index 1c77389..f270ac0 100644
--- a/audio/audio.c
+++ b/audio/audio.c
@@ -22,7 +22,7 @@
  * THE SOFTWARE.
  */
 #include "hw/hw.h"
-#include "audio.h"
+#include "audio/audio.h"
 #include "monitor.h"
 #include "qemu-timer.h"
 #include "sysemu.h"
diff --git a/audio/audio_pt_int.c b/audio/audio_pt_int.c
index 9a9c306..97e36ab 100644
--- a/audio/audio_pt_int.c
+++ b/audio/audio_pt_int.c
@@ -1,5 +1,5 @@
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "audio-pt"
 
diff --git a/audio/audio_win_int.c b/audio/audio_win_int.c
index 5869052..071f52c 100644
--- a/audio/audio_win_int.c
+++ b/audio/audio_win_int.c
@@ -1,13 +1,12 @@
 /* public domain */
 
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "win-int"
 #include <windows.h>
 #include <mmsystem.h>
 
-#include "audio.h"
 #include "audio_int.h"
 #include "audio_win_int.h"
 
diff --git a/audio/coreaudio.c b/audio/coreaudio.c
index 5964c62..d0db2a2 100644
--- a/audio/coreaudio.c
+++ b/audio/coreaudio.c
@@ -27,7 +27,7 @@
 #include <pthread.h>            /* pthread_X */
 
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "coreaudio"
 #include "audio_int.h"
diff --git a/audio/dsoundaudio.c b/audio/dsoundaudio.c
index e2d89fd..b26705d 100644
--- a/audio/dsoundaudio.c
+++ b/audio/dsoundaudio.c
@@ -27,7 +27,7 @@
  */
 
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "dsound"
 #include "audio_int.h"
diff --git a/audio/esdaudio.c b/audio/esdaudio.c
index eea9cce..c1d974f 100644
--- a/audio/esdaudio.c
+++ b/audio/esdaudio.c
@@ -23,7 +23,7 @@
  */
 #include <esd.h>
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "esd"
 #include "audio_int.h"
diff --git a/audio/fmodaudio.c b/audio/fmodaudio.c
index fabf84d..43d17d5 100644
--- a/audio/fmodaudio.c
+++ b/audio/fmodaudio.c
@@ -24,7 +24,7 @@
 #include <fmod.h>
 #include <fmod_errors.h>
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "fmod"
 #include "audio_int.h"
diff --git a/audio/mixeng.c b/audio/mixeng.c
index 02a9d9f..47a4e51 100644
--- a/audio/mixeng.c
+++ b/audio/mixeng.c
@@ -23,7 +23,7 @@
  * THE SOFTWARE.
  */
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "mixeng"
 #include "audio_int.h"
diff --git a/audio/noaudio.c b/audio/noaudio.c
index 54958f8..fd40758 100644
--- a/audio/noaudio.c
+++ b/audio/noaudio.c
@@ -22,7 +22,7 @@
  * THE SOFTWARE.
  */
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 #include "qemu-timer.h"
 
 #define AUDIO_CAP "noaudio"
diff --git a/audio/ossaudio.c b/audio/ossaudio.c
index 8249a00..2c4a0db 100644
--- a/audio/ossaudio.c
+++ b/audio/ossaudio.c
@@ -33,7 +33,7 @@
 #include "qemu-common.h"
 #include "main-loop.h"
 #include "host-utils.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "oss"
 #include "audio_int.h"
diff --git a/audio/paaudio.c b/audio/paaudio.c
index 8b69778..050e076 100644
--- a/audio/paaudio.c
+++ b/audio/paaudio.c
@@ -1,6 +1,6 @@
 /* public domain */
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #include <pulse/pulseaudio.h>
 
diff --git a/audio/sdlaudio.c b/audio/sdlaudio.c
index d24daa5..70fab41 100644
--- a/audio/sdlaudio.c
+++ b/audio/sdlaudio.c
@@ -24,7 +24,7 @@
 #include <SDL.h>
 #include <SDL_thread.h>
 #include "qemu-common.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #ifndef _WIN32
 #ifdef __sun__
diff --git a/audio/spiceaudio.c b/audio/spiceaudio.c
index 6f15591..4950e5b 100644
--- a/audio/spiceaudio.c
+++ b/audio/spiceaudio.c
@@ -22,7 +22,7 @@
 #include "ui/qemu-spice.h"
 
 #define AUDIO_CAP "spice"
-#include "audio.h"
+#include "audio/audio.h"
 #include "audio_int.h"
 
 #define LINE_IN_SAMPLES 1024
diff --git a/audio/wavaudio.c b/audio/wavaudio.c
index a449b51..96c0a83 100644
--- a/audio/wavaudio.c
+++ b/audio/wavaudio.c
@@ -23,7 +23,7 @@
  */
 #include "hw/hw.h"
 #include "qemu-timer.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "wav"
 #include "audio_int.h"
diff --git a/audio/wavcapture.c b/audio/wavcapture.c
index 4f785f5..b897e26 100644
--- a/audio/wavcapture.c
+++ b/audio/wavcapture.c
@@ -1,6 +1,6 @@
 #include "hw/hw.h"
 #include "monitor.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 typedef struct {
     FILE *f;
diff --git a/audio/winwaveaudio.c b/audio/winwaveaudio.c
index 72babbf..34bcd47 100644
--- a/audio/winwaveaudio.c
+++ b/audio/winwaveaudio.c
@@ -2,7 +2,7 @@
 
 #include "qemu-common.h"
 #include "sysemu.h"
-#include "audio.h"
+#include "audio/audio.h"
 
 #define AUDIO_CAP "winwave"
 #include "audio_int.h"