diff --git a/audio/alsaaudio.c b/audio/alsaaudio.c
index 564d632..cd553c2 100644
--- a/audio/alsaaudio.c
+++ b/audio/alsaaudio.c
@@ -24,7 +24,6 @@
 #include <alsa/asoundlib.h>
 #include "qemu-common.h"
 #include "main-loop.h"
-#include "qemu-char.h"
 #include "audio.h"
 
 #if QEMU_GNUC_PREREQ(4, 3)
diff --git a/audio/ossaudio.c b/audio/ossaudio.c
index 45abe39..8249a00 100644
--- a/audio/ossaudio.c
+++ b/audio/ossaudio.c
@@ -33,7 +33,6 @@
 #include "qemu-common.h"
 #include "main-loop.h"
 #include "host-utils.h"
-#include "qemu-char.h"
 #include "audio.h"
 
 #define AUDIO_CAP "oss"
diff --git a/block/raw-posix.c b/block/raw-posix.c
index 550c81f..aa8b96f 100644
--- a/block/raw-posix.c
+++ b/block/raw-posix.c
@@ -23,7 +23,6 @@
  */
 #include "qemu-common.h"
 #include "qemu-timer.h"
-#include "qemu-char.h"
 #include "qemu-log.h"
 #include "block_int.h"
 #include "module.h"
diff --git a/bt-host.c b/bt-host.c
index 8b47370..3118645 100644
--- a/bt-host.c
+++ b/bt-host.c
@@ -18,7 +18,6 @@
  */
 
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "net.h"
 #include "bt-host.h"
 #include "main-loop.h"
diff --git a/bt-vhci.c b/bt-vhci.c
index 878460a..6fecb66 100644
--- a/bt-vhci.c
+++ b/bt-vhci.c
@@ -18,7 +18,6 @@
  */
 
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "net.h"
 #include "hw/bt.h"
 #include "main-loop.h"
diff --git a/buffered_file.c b/buffered_file.c
index bd0f61d..f13443e 100644
--- a/buffered_file.c
+++ b/buffered_file.c
@@ -16,7 +16,6 @@
 #include "qemu-common.h"
 #include "hw/hw.h"
 #include "qemu-timer.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 
 //#define DEBUG_BUFFERED_FILE
diff --git a/console.c b/console.c
index 048b48e..9ac7b28 100644
--- a/console.c
+++ b/console.c
@@ -25,6 +25,7 @@
 #include "console.h"
 #include "qemu-timer.h"
 #include "qmp-commands.h"
+#include "qemu-char.h"
 
 //#define DEBUG_CONSOLE
 #define DEFAULT_BACKSCROLL 512
diff --git a/console.h b/console.h
index 50a0512..6fcca23 100644
--- a/console.h
+++ b/console.h
@@ -1,7 +1,6 @@
 #ifndef CONSOLE_H
 #define CONSOLE_H
 
-#include "qemu-char.h"
 #include "qemu-pixman.h"
 #include "qdict.h"
 #include "notify.h"
diff --git a/hmp.c b/hmp.c
index 180ba2b..873962f 100644
--- a/hmp.c
+++ b/hmp.c
@@ -15,6 +15,7 @@
 
 #include "hmp.h"
 #include "net.h"
+#include "qemu-char.h"
 #include "qemu-option.h"
 #include "qemu-timer.h"
 #include "qmp-commands.h"
diff --git a/hw/9pfs/virtio-9p-coth.c b/hw/9pfs/virtio-9p-coth.c
index 25556cc..9368df7 100644
--- a/hw/9pfs/virtio-9p-coth.c
+++ b/hw/9pfs/virtio-9p-coth.c
@@ -12,7 +12,6 @@
  *
  */
 
-#include "qemu-char.h"
 #include "fsdev/qemu-fsdev.h"
 #include "qemu-thread.h"
 #include "qemu-coroutine.h"
diff --git a/hw/ivshmem.c b/hw/ivshmem.c
index f6dbb21..320ac8d 100644
--- a/hw/ivshmem.c
+++ b/hw/ivshmem.c
@@ -24,6 +24,7 @@
 #include "migration.h"
 #include "qerror.h"
 #include "event_notifier.h"
+#include "qemu-char.h"
 
 #include <sys/mman.h>
 #include <sys/types.h>
diff --git a/hw/spapr_hcall.c b/hw/spapr_hcall.c
index 63cadb8..1fac362 100644
--- a/hw/spapr_hcall.c
+++ b/hw/spapr_hcall.c
@@ -1,8 +1,6 @@
 #include "sysemu.h"
 #include "cpu.h"
-#include "qemu-char.h"
 #include "sysemu.h"
-#include "qemu-char.h"
 #include "helper_regs.h"
 #include "hw/spapr.h"
 
diff --git a/hw/strongarm.c b/hw/strongarm.c
index 4385515..44bec34 100644
--- a/hw/strongarm.c
+++ b/hw/strongarm.c
@@ -30,6 +30,7 @@
 #include "strongarm.h"
 #include "qemu-error.h"
 #include "arm-misc.h"
+#include "qemu-char.h"
 #include "sysemu.h"
 #include "ssi.h"
 
diff --git a/hw/xen_disk.c b/hw/xen_disk.c
index e6bb2f2..423b580 100644
--- a/hw/xen_disk.c
+++ b/hw/xen_disk.c
@@ -36,7 +36,6 @@
 #include <sys/uio.h>
 
 #include "hw.h"
-#include "qemu-char.h"
 #include "xen_backend.h"
 #include "xen_blkif.h"
 #include "blockdev.h"
diff --git a/hw/xen_nic.c b/hw/xen_nic.c
index cf7d559..dadacb1 100644
--- a/hw/xen_nic.c
+++ b/hw/xen_nic.c
@@ -39,7 +39,6 @@
 #include "net.h"
 #include "net/checksum.h"
 #include "net/util.h"
-#include "qemu-char.h"
 #include "xen_backend.h"
 
 #include <xen/io/netif.h>
diff --git a/hw/xilinx_axidma.c b/hw/xilinx_axidma.c
index 4575da1..2fd6068 100644
--- a/hw/xilinx_axidma.c
+++ b/hw/xilinx_axidma.c
@@ -23,7 +23,6 @@
  */
 
 #include "sysbus.h"
-#include "qemu-char.h"
 #include "qemu-timer.h"
 #include "ptimer.h"
 #include "qemu-log.h"
diff --git a/hw/xilinx_axienet.c b/hw/xilinx_axienet.c
index f2e3bf1..c859fde 100644
--- a/hw/xilinx_axienet.c
+++ b/hw/xilinx_axienet.c
@@ -23,7 +23,6 @@
  */
 
 #include "sysbus.h"
-#include "qemu-char.h"
 #include "qemu-log.h"
 #include "net.h"
 #include "net/checksum.h"
diff --git a/hw/xtensa_lx60.c b/hw/xtensa_lx60.c
index 4c42edc..bc10d31 100644
--- a/hw/xtensa_lx60.c
+++ b/hw/xtensa_lx60.c
@@ -36,6 +36,7 @@
 #include "sysbus.h"
 #include "flash.h"
 #include "blockdev.h"
+#include "qemu-char.h"
 #include "xtensa_bootparam.h"
 
 typedef struct LxBoardDesc {
diff --git a/iohandler.c b/iohandler.c
index 60460a6..258f42d 100644
--- a/iohandler.c
+++ b/iohandler.c
@@ -24,7 +24,6 @@
 
 #include "config-host.h"
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "qemu-queue.h"
 #include "qemu-aio.h"
 #include "main-loop.h"
diff --git a/migration-exec.c b/migration-exec.c
index 2b6fcb4..b4a3ca3 100644
--- a/migration-exec.c
+++ b/migration-exec.c
@@ -18,7 +18,6 @@
 #include "qemu-common.h"
 #include "qemu_socket.h"
 #include "migration.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 #include <sys/types.h>
diff --git a/migration-fd.c b/migration-fd.c
index 5fe28e0..6d42287 100644
--- a/migration-fd.c
+++ b/migration-fd.c
@@ -17,7 +17,6 @@
 #include "qemu_socket.h"
 #include "migration.h"
 #include "monitor.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 #include "qemu_socket.h"
diff --git a/migration-tcp.c b/migration-tcp.c
index 5e855fe..a9bb817 100644
--- a/migration-tcp.c
+++ b/migration-tcp.c
@@ -16,7 +16,6 @@
 #include "qemu-common.h"
 #include "qemu_socket.h"
 #include "migration.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 
diff --git a/migration-unix.c b/migration-unix.c
index dba72b4..e58e8bc 100644
--- a/migration-unix.c
+++ b/migration-unix.c
@@ -16,7 +16,6 @@
 #include "qemu-common.h"
 #include "qemu_socket.h"
 #include "migration.h"
-#include "qemu-char.h"
 #include "buffered_file.h"
 #include "block.h"
 
diff --git a/monitor.h b/monitor.h
index b4ef955..4595c21 100644
--- a/monitor.h
+++ b/monitor.h
@@ -2,7 +2,6 @@
 #define MONITOR_H
 
 #include "qemu-common.h"
-#include "qemu-char.h"
 #include "qerror.h"
 #include "qdict.h"
 #include "block.h"
diff --git a/net/slirp.c b/net/slirp.c
index afb52c3..f117412 100644
--- a/net/slirp.c
+++ b/net/slirp.c
@@ -35,6 +35,7 @@
 #include "monitor.h"
 #include "qemu_socket.h"
 #include "slirp/libslirp.h"
+#include "qemu-char.h"
 
 static int get_str_sep(char *buf, int buf_size, const char **pp, int sep)
 {
diff --git a/net/socket.c b/net/socket.c
index c01323d..cf309cd 100644
--- a/net/socket.c
+++ b/net/socket.c
@@ -26,7 +26,6 @@
 #include "net.h"
 #include "clients.h"
 #include "monitor.h"
-#include "qemu-char.h"
 #include "qemu-common.h"
 #include "qemu-error.h"
 #include "qemu-option.h"
diff --git a/net/tap.c b/net/tap.c
index 1abfd44..5ff7893 100644
--- a/net/tap.c
+++ b/net/tap.c
@@ -37,7 +37,6 @@
 #include "clients.h"
 #include "monitor.h"
 #include "sysemu.h"
-#include "qemu-char.h"
 #include "qemu-common.h"
 #include "qemu-error.h"
 
diff --git a/net/vde.c b/net/vde.c
index 275bda9..cc5a07d 100644
--- a/net/vde.c
+++ b/net/vde.c
@@ -27,7 +27,6 @@
 
 #include "net.h"
 #include "clients.h"
-#include "qemu-char.h"
 #include "qemu-common.h"
 #include "qemu-option.h"
 
diff --git a/qmp.c b/qmp.c
index e3a7f0b..e873f0a 100644
--- a/qmp.c
+++ b/qmp.c
@@ -16,6 +16,7 @@
 #include "qemu-common.h"
 #include "sysemu.h"
 #include "qmp-commands.h"
+#include "qemu-char.h"
 #include "ui/qemu-spice.h"
 #include "ui/vnc.h"
 #include "kvm.h"
diff --git a/savevm.c b/savevm.c
index 5d04d59..f5886ce 100644
--- a/savevm.c
+++ b/savevm.c
@@ -76,7 +76,6 @@
 #include "monitor.h"
 #include "sysemu.h"
 #include "qemu-timer.h"
-#include "qemu-char.h"
 #include "audio/audio.h"
 #include "migration.h"
 #include "qemu_socket.h"
diff --git a/ui/qemu-spice.h b/ui/qemu-spice.h
index 3299da8..5857b8a 100644
--- a/ui/qemu-spice.h
+++ b/ui/qemu-spice.h
@@ -24,7 +24,6 @@
 
 #include "qemu-option.h"
 #include "qemu-config.h"
-#include "qemu-char.h"
 #include "monitor.h"
 
 extern int using_spice;